@inproceedings{bohannon_boomerang_2008,
	address = {San Francisco, California, USA},
	series = {{POPL} '08},
	title = {Boomerang: resourceful lenses for string data},
	isbn = {978-1-59593-689-9},
	shorttitle = {Boomerang},
	url = {https://doi.org/10.1145/1328438.1328487},
	doi = {10.1145/1328438.1328487},
	abstract = {A lens is a bidirectional program. When read from left toright, it denotes an ordinary function that maps inputs to outputs. When read from right to left, it denotes an ''update translator'' that takes an input together with an updated output and produces a new input that reflects the update. Many variants of this idea have been explored in the literature, but none deal fully with ordered data. If, for example, an update changes the order of a list in theoutput, the items in the output list and the chunks of the input that generated them can be misaligned, leading to lost or corrupted data. We attack this problem in the context of bidirectional transformations over strings, the primordial ordered data type. We first propose a collection of bidirectional string lens combinators, based on familiar operations on regular transducers (union, concatenation, Kleene-star) and with a type system based on regular expressions. We then design anew semantic space of dictionary lenses, enriching the lenses of Foster et al. (2007) with support for two additional combinators for marking ''reorderable chunks'' andtheir keys. To demonstrate the effectiveness of these primitives, we describe the design and implementation of Boomerang, a full-blown bidirectional programming language with dictionary lenses at its core. We have used Boomerang to build transformers for complex real-world data format sincluding the SwissProt genomic database. We formalize the essential property of resourcefulness-the correct use of keys to associate chunks in the input and output-by defining a refined semantic space of quasi-oblivious lenses. Several previously studied properties of lenses turn out to have compact characterizations in this space.},
	urldate = {2020-05-28},
	booktitle = {Proceedings of the 35th annual {ACM} {SIGPLAN}-{SIGACT} symposium on {Principles} of programming languages},
	publisher = {Association for Computing Machinery},
	author = {Bohannon, Aaron and Foster, J. Nathan and Pierce, Benjamin C. and Pilkiewicz, Alexandre and Schmitt, Alan},
	month = jan,
	year = {2008},
	keywords = {bidirectional languages, lenses, regular string transducers, regular types, view update problem},
	pages = {407--419},
}

@article{foster_combinators_2007,
	title = {Combinators for bidirectional tree transformations: {A} linguistic approach to the view-update problem},
	volume = {29},
	issn = {0164-0925},
	shorttitle = {Combinators for bidirectional tree transformations},
	url = {https://doi.org/10.1145/1232420.1232424},
	doi = {10.1145/1232420.1232424},
	abstract = {We propose a novel approach to the view-update problem for tree-structured data: a domain-specific programming language in which all expressions denote bidirectional transformations on trees. In one direction, these transformations---dubbed lenses---map a concrete tree into a simplified abstract view; in the other, they map a modified abstract view, together with the original concrete tree, to a correspondingly modified concrete tree. Our design emphasizes both robustness and ease of use, guaranteeing strong well-behavedness and totality properties for well-typed lenses. We begin by identifying a natural space of well-behaved bidirectional transformations over arbitrary structures, studying definedness and continuity in this setting. We then instantiate this semantic framework in the form of a collection of lens combinators that can be assembled to describe bidirectional transformations on trees. These combinators include familiar constructs from functional programming (composition, mapping, projection, conditionals, recursion) together with some novel primitives for manipulating trees (splitting, pruning, merging, etc.). We illustrate the expressiveness of these combinators by developing a number of bidirectional list-processing transformations as derived forms. An extended example shows how our combinators can be used to define a lens that translates between a native HTML representation of browser bookmarks and a generic abstract bookmark format.},
	number = {3},
	urldate = {2020-05-28},
	journal = {ACM Transactions on Programming Languages and Systems},
	author = {Foster, J. Nathan and Greenwald, Michael B. and Moore, Jonathan T. and Pierce, Benjamin C. and Schmitt, Alan},
	month = may,
	year = {2007},
	keywords = {lenses, view update problem, Bidirectional programming, Harmony, XML},
	pages = {17--es},
}

@article{foster_quotient_2008,
	title = {Quotient lenses},
	volume = {43},
	number = {9},
	journal = {ACM Sigplan Notices},
	author = {Foster, J. Nathan and Pilkiewicz, Alexandre and Pierce, Benjamin C.},
	year = {2008},
	note = {Publisher: ACM New York, NY, USA},
	pages = {383--396},
}

@article{hofmann_symmetric_2011,
	title = {Symmetric lenses},
	volume = {46},
	number = {1},
	journal = {ACM SIGPLAN Notices},
	author = {Hofmann, Martin and Pierce, Benjamin and Wagner, Daniel},
	year = {2011},
	note = {Publisher: ACM New York, NY, USA},
	pages = {371--384},
}

@article{koppel_one_2018,
	title = {One tool, many languages: language-parametric transformation with incremental parametric syntax},
	volume = {2},
	shorttitle = {One tool, many languages},
	url = {https://doi.org/10.1145/3276492},
	doi = {10.1145/3276492},
	abstract = {We present a new approach for building source-to-source transformations that can run on multiple programming languages, based on a new way of representing programs called incremental parametric syntax. We implement this approach in Haskell in our Cubix system, and construct incremental parametric syntaxes for C, Java, JavaScript, Lua, and Python. We demonstrate a whole-program refactoring tool that runs on all of them, along with three smaller transformations that each run on several. Our evaluation shows that (1) once a transformation is written, little work is required to configure it for a new language (2) transformations built this way output readable code which preserve the structure of the original, according to participants in our human study, and (3) our transformations can still handle language corner-cases, as validated on compiler test suites.},
	number = {OOPSLA},
	urldate = {2020-06-12},
	journal = {Proceedings of the ACM on Programming Languages},
	author = {Koppel, James and Premtoon, Varot and Solar-Lezama, Armando},
	month = oct,
	year = {2018},
	keywords = {program transformation, expression problem, refactoring},
	pages = {122:1--122:28},
}

@article{martins_trinity_2019,
	title = {Trinity: {An} extensible synthesis framework for data science},
	volume = {12},
	shorttitle = {Trinity},
	number = {12},
	journal = {Proceedings of the VLDB Endowment},
	author = {Martins, Ruben and Chen, Jia and Chen, Yanju and Feng, Yu and Dillig, Isil},
	year = {2019},
	note = {Publisher: VLDB Endowment},
	pages = {1914--1917},
}
